package DataLayer;

import FunctionLayer.Datahandler;
import edu.stanford.nlp.pipeline.StanfordCoreNLP;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.*;
import java.util.Properties;

public class ThreadClient {
    public ThreadClient(int port, Datahandler datahandler, StanfordCoreNLP stanfordCoreNLP, StanfordCoreNLP stanfordCoreNLPSentiment) {
        Properties prop = new Properties();
        String fileName = "app.config";
        try (FileInputStream fis = new FileInputStream(fileName)) {
            prop.load(fis);
        } catch (FileNotFoundException ex) {
        } catch (IOException ex) {
        }

        String hostIP = prop.getProperty("app.hostip");
        if (port == Integer.valueOf(prop.getProperty("app.hostport"))
                || port == Integer.valueOf(prop.getProperty("app.hostport2"))) {
            hostIP = prop.getProperty("app.hostip2");
        }
        try {
            InetAddress ipAddress = InetAddress.getByName(hostIP);//used ip's
            try (DatagramSocket serverSocket = new DatagramSocket(port)) {
                while (true) {
                    receiveAndSendPacket(serverSocket, ipAddress, port, datahandler, stanfordCoreNLP, stanfordCoreNLPSentiment);
                }
            } catch (SocketException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
        } catch (UnknownHostException e) {
            e.printStackTrace();
        }
    }


    private static void receiveAndSendPacket(DatagramSocket serverSocket, InetAddress ipAddress, int port,
                                             Datahandler datahandler, StanfordCoreNLP stanfordCoreNLP, StanfordCoreNLP stanfordCoreNLPSentiment) throws
            IOException {
        byte[] receiveData = new byte[4096];
        DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
        try {
            serverSocket.receive(receivePacket);
        } catch (IOException e) {
            e.printStackTrace();
        }
        String sentence = new String(receivePacket.getData(), 0,
                receivePacket.getLength());
        sentence = sentence.replace("clientmessage:", "");
        String ResponseMsg = datahandler.getResponseMsg(sentence, "", stanfordCoreNLP, stanfordCoreNLPSentiment,
                true);
        byte[] sendData = new byte[0];
        try {
            sendData = ResponseMsg.getBytes("UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        int deliver_port = 0;
        switch (port) {
            case 48475:
                deliver_port = 48470;
                break;
            case 48476:
                deliver_port = 48471;
                break;
            case 48477:
                deliver_port = 48472;
                break;
            case 48478:
                deliver_port = 48473;
                break;
        }
        DatagramPacket sendPacket = new DatagramPacket(sendData, sendData.length, ipAddress, deliver_port);
        try {
            serverSocket.send(sendPacket);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
